package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.Building;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class BuildingNode extends Renderable {

	private Building building;

	public BuildingNode(Building building) {
		this.building = building;
	}

	@Override
	public String getText() {
		return building.getGmlId().getGmlString();
	}
	
	public Building getBuilding() {
		return building;
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.render(building);
	}

	@Override
	public void refreshTextColor() {
		if (!building.isValidated()) {
			setStatus(CheckStatus.NOT_CHECKED);
		} else if (building.containsAnyError()) {
			setStatus(CheckStatus.ERROR);
		} else {
			setStatus(CheckStatus.OK);
		}
	}

}
