package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.Installation;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class InstallationNode extends Renderable {

	private Installation bi;

	public InstallationNode(Installation bi) {
		this.bi = bi;
	}

	@Override
	public String getText() {
		return bi.getGmlId().getGmlString();
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.render(bi);
	}

	@Override
	public void refreshTextColor() {
		if (!bi.isValidated()) {
			setStatus(CheckStatus.NOT_CHECKED);
		} else if (bi.containsAnyError()) {
			setStatus(CheckStatus.ERROR);
		} else {
			setStatus(CheckStatus.OK);
		}
	}
}