package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.check.DefaultParameter;
import de.hft.stuttgart.citydoctor2.check.Requirement;
import javafx.beans.property.BooleanProperty;
import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.value.ObservableValue;

public class TreeRequirement {
	
	private BooleanProperty enabled;
	private ObservableValue<String> name;
	private SimpleStringProperty value;
	private ObservableValue<String> unit;
	
	private Requirement r;
	
	public TreeRequirement(Requirement r) {
		this.r = r;
		enabled = new SimpleBooleanProperty(true);
		name = new SimpleStringProperty(r.getId());
		unit = new SimpleStringProperty();
	}
	
	public TreeRequirement(DefaultParameter dp) {
		name = new SimpleStringProperty(dp.getName());
		value = new SimpleStringProperty(dp.getValue());
		unit = new SimpleStringProperty(dp.getUnitType().getRepresentation());
	}
	
	public void setEnabled(boolean enabled) {
		this.enabled.set(enabled);
	}

	public ObservableValue<String> getUnitProperty() {
		return unit;
	}

	/**
	 * @return the enabled
	 */
	public BooleanProperty getEnabledProperty() {
		return enabled;
	}

	public ObservableValue<String> getNameProperty() {
		return name;
	}
	
	public ObservableValue<String> getValueProperty() {
		return value;
	}
	
	public void setValue(String value) {
		this.value.setValue(value);
	}
	
	public Requirement getRequirement() {
		return r;
	}

	public boolean isEnabled() {
		return enabled.get();
	}

}
