package de.hft.stuttgart.citydoctor2.webservice.endpoints;

import static org.junit.Assert.assertEquals;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.junit.Test;

import de.hft.stuttgart.citydoctor2.webservice.database.UserQueries;
import de.hft.stuttgart.citydoctor2.webservice.utils.HibernateUtils;

public class RegisterEndpointTest {

	@Test
	public void testRegisterExistingUser() throws ClientProtocolException, IOException {
		HttpClient client = HttpClients.createMinimal();
		HttpPost post = new HttpPost("http://localhost:8080/CityDoctorWebService/rest/register");
		
		List<NameValuePair> params = new ArrayList<NameValuePair>(2);
		params.add(new BasicNameValuePair("username", "Test"));
		params.add(new BasicNameValuePair("password", "TestPassword"));
		post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
		
		HttpResponse response = client.execute(post);
		assertEquals(409, response.getStatusLine().getStatusCode());
	}
	
	@Test
	public void testRegisterNewUser() throws ClientProtocolException, IOException {
		HttpClient client = HttpClients.createMinimal();
		HttpPost post = new HttpPost("http://localhost:8080/CityDoctorWebService/rest/register");
		
		List<NameValuePair> params = new ArrayList<NameValuePair>(2);
		params.add(new BasicNameValuePair("username", "TestNotExisting"));
		params.add(new BasicNameValuePair("password", "TestPassword"));
		post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
		
		HttpResponse response = client.execute(post);
		assertEquals(200, response.getStatusLine().getStatusCode());
		
		EntityManager manager = HibernateUtils.createManager();
		UserQueries.deleteUser(UserQueries.getUserForUsername("TestNotExisting", manager), manager);
		manager.close();
	}

}
